"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const N = require("vue"), b = require("@nextcloud/axios"), P = require("@nextcloud/vue/dist/Components/NcButton.js"), T = require("@nextcloud/vue/dist/Components/NcModal.js"), M = require("@nextcloud/vue/dist/Components/NcNoteCard.js"), x = require("@nextcloud/vue/dist/Components/NcPasswordField.js"), D = require("@nextcloud/router"), q = require("@nextcloud/l10n/gettext"), c = (t) => t && t.__esModule ? t : { default: t }, g = /* @__PURE__ */ c(N), $ = /* @__PURE__ */ c(b), E = /* @__PURE__ */ c(P), L = /* @__PURE__ */ c(T), k = /* @__PURE__ */ c(M), A = /* @__PURE__ */ c(x), m = "password-confirmation-dialog", B = "modal-mask", h = q.getGettextBuilder().detectLocale();
[].map(({ locale: t, json: e }) => h.addTranslation(t, e));
const f = h.build();
f.ngettext.bind(f);
const l = f.gettext.bind(f), S = g.default.extend({
  name: "PasswordDialog",
  components: {
    NcButton: E.default,
    NcModal: L.default,
    NcNoteCard: k.default,
    NcPasswordField: A.default
  },
  data() {
    return {
      password: "",
      showError: !1,
      dialogId: m,
      titleText: l("Authentication required"),
      subtitleText: l("This action requires you to confirm your password"),
      passwordLabelText: l("Password"),
      errorText: l("Failed to authenticate, please try again"),
      confirmText: l("Confirm")
    };
  },
  mounted() {
    this.$nextTick(() => {
      this.$refs.field.$el.querySelector('input[type="password"]').focus();
    });
  },
  methods: {
    async confirm() {
      this.showError = !1;
      const t = D.generateUrl("/login/confirm");
      try {
        const { data: e } = await $.default.post(t, { password: this.password });
        window.nc_lastLogin = e.lastLogin, this.$emit("confirmed");
      } catch {
        this.showError = !0;
      }
    },
    close() {
      this.$emit("close");
    }
  }
});
function R(t, e, o, r, i, d, u, _) {
  var n = typeof t == "function" ? t.options : t;
  e && (n.render = e, n.staticRenderFns = o, n._compiled = !0), r && (n.functional = !0), d && (n._scopeId = "data-v-" + d);
  var a;
  if (u ? (a = function(s) {
    s = s || // cached call
    this.$vnode && this.$vnode.ssrContext || // stateful
    this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, !s && typeof __VUE_SSR_CONTEXT__ < "u" && (s = __VUE_SSR_CONTEXT__), i && i.call(this, s), s && s._registeredComponents && s._registeredComponents.add(u);
  }, n._ssrRegister = a) : i && (a = _ ? function() {
    i.call(
      this,
      (n.functional ? this.parent : this).$root.$options.shadowRoot
    );
  } : i), a)
    if (n.functional) {
      n._injectStyles = a;
      var y = n.render;
      n.render = function(C, w) {
        return a.call(w), y(C, w);
      };
    } else {
      var p = n.beforeCreate;
      n.beforeCreate = p ? [].concat(p, a) : [a];
    }
  return {
    exports: t,
    options: n
  };
}
var F = function() {
  var e = this, o = e._self._c;
  return e._self._setupProxy, o("NcModal", { staticClass: "dialog", attrs: { id: e.dialogId, size: "small", container: null }, on: { close: e.close } }, [o("div", { staticClass: "dialog__container" }, [o("h2", { staticClass: "dialog__title" }, [e._v(" " + e._s(e.titleText) + " ")]), o("p", [e._v(e._s(e.subtitleText))]), o("NcPasswordField", { ref: "field", attrs: { value: e.password, label: e.passwordLabelText }, on: { "update:value": function(r) {
    e.password = r;
  }, keydown: function(r) {
    return !r.type.indexOf("key") && e._k(r.keyCode, "enter", 13, r.key, "Enter") ? null : e.confirm.apply(null, arguments);
  } } }), e.showError ? o("NcNoteCard", { attrs: { "show-alert": !0 } }, [o("p", [e._v(e._s(e.errorText))])]) : e._e(), o("NcButton", { staticClass: "dialog__button", attrs: { type: "primary", "aria-label": e.confirmText }, on: { click: e.confirm } }, [e._v(" " + e._s(e.confirmText) + " ")])], 1)]);
}, O = [], I = /* @__PURE__ */ R(
  S,
  F,
  O,
  !1,
  null,
  "bf24972b",
  null,
  null
);
const V = I.exports, G = Date.now(), v = () => {
  const t = G - window.nc_pageLoad * 1e3, e = Date.now() - (t + window.nc_lastLogin * 1e3);
  return window.backendAllowsPasswordConfirmation && e > 30 * 60 * 1e3;
}, U = () => {
  if (!!document.getElementById(m))
    return Promise.reject(new Error(l("Password confirmation dialog already mounted")));
  if (!v())
    return Promise.resolve();
  const e = document.createElement("div");
  e.setAttribute("id", m);
  const o = document.querySelectorAll(".".concat(B));
  !!o.length ? o[o.length - 1].prepend(e) : document.body.prepend(e);
  const i = g.default.extend(V), d = new i().$mount(e);
  return new Promise((u, _) => {
    d.$on("confirmed", () => {
      d.$destroy(), u();
    }), d.$on("close", () => {
      d.$destroy(), _(new Error("Dialog closed"));
    });
  });
};
exports.confirmPassword = U;
exports.isPasswordConfirmationRequired = v;
