import w from "vue";
import y from "@nextcloud/axios";
import C from "@nextcloud/vue/dist/Components/NcButton.js";
import T from "@nextcloud/vue/dist/Components/NcModal.js";
import b from "@nextcloud/vue/dist/Components/NcNoteCard.js";
import P from "@nextcloud/vue/dist/Components/NcPasswordField.js";
import { generateUrl as x } from "@nextcloud/router";
import { getGettextBuilder as D } from "@nextcloud/l10n/gettext";
const m = "password-confirmation-dialog", $ = "modal-mask", g = D().detectLocale();
[].map(({ locale: r, json: o }) => g.addTranslation(r, o));
const u = g.build();
u.ngettext.bind(u);
const l = u.gettext.bind(u), E = w.extend({
  name: "PasswordDialog",
  components: {
    NcButton: C,
    NcModal: T,
    NcNoteCard: b,
    NcPasswordField: P
  },
  data() {
    return {
      password: "",
      showError: !1,
      dialogId: m,
      titleText: l("Authentication required"),
      subtitleText: l("This action requires you to confirm your password"),
      passwordLabelText: l("Password"),
      errorText: l("Failed to authenticate, please try again"),
      confirmText: l("Confirm")
    };
  },
  mounted() {
    this.$nextTick(() => {
      this.$refs.field.$el.querySelector('input[type="password"]').focus();
    });
  },
  methods: {
    async confirm() {
      this.showError = !1;
      const r = x("/login/confirm");
      try {
        const { data: o } = await y.post(r, { password: this.password });
        window.nc_lastLogin = o.lastLogin, this.$emit("confirmed");
      } catch {
        this.showError = !0;
      }
    },
    close() {
      this.$emit("close");
    }
  }
});
function L(r, o, e, s, a, d, c, f) {
  var t = typeof r == "function" ? r.options : r;
  o && (t.render = o, t.staticRenderFns = e, t._compiled = !0), s && (t.functional = !0), d && (t._scopeId = "data-v-" + d);
  var i;
  if (c ? (i = function(n) {
    n = n || // cached call
    this.$vnode && this.$vnode.ssrContext || // stateful
    this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, !n && typeof __VUE_SSR_CONTEXT__ < "u" && (n = __VUE_SSR_CONTEXT__), a && a.call(this, n), n && n._registeredComponents && n._registeredComponents.add(c);
  }, t._ssrRegister = i) : a && (i = f ? function() {
    a.call(
      this,
      (t.functional ? this.parent : this).$root.$options.shadowRoot
    );
  } : a), i)
    if (t.functional) {
      t._injectStyles = i;
      var h = t.render;
      t.render = function(v, p) {
        return i.call(p), h(v, p);
      };
    } else {
      var _ = t.beforeCreate;
      t.beforeCreate = _ ? [].concat(_, i) : [i];
    }
  return {
    exports: r,
    options: t
  };
}
var M = function() {
  var o = this, e = o._self._c;
  return o._self._setupProxy, e("NcModal", { staticClass: "dialog", attrs: { id: o.dialogId, size: "small", container: null }, on: { close: o.close } }, [e("div", { staticClass: "dialog__container" }, [e("h2", { staticClass: "dialog__title" }, [o._v(" " + o._s(o.titleText) + " ")]), e("p", [o._v(o._s(o.subtitleText))]), e("NcPasswordField", { ref: "field", attrs: { value: o.password, label: o.passwordLabelText }, on: { "update:value": function(s) {
    o.password = s;
  }, keydown: function(s) {
    return !s.type.indexOf("key") && o._k(s.keyCode, "enter", 13, s.key, "Enter") ? null : o.confirm.apply(null, arguments);
  } } }), o.showError ? e("NcNoteCard", { attrs: { "show-alert": !0 } }, [e("p", [o._v(o._s(o.errorText))])]) : o._e(), e("NcButton", { staticClass: "dialog__button", attrs: { type: "primary", "aria-label": o.confirmText }, on: { click: o.confirm } }, [o._v(" " + o._s(o.confirmText) + " ")])], 1)]);
}, N = [], k = /* @__PURE__ */ L(
  E,
  M,
  N,
  !1,
  null,
  "bf24972b",
  null,
  null
);
const A = k.exports, B = Date.now(), R = () => {
  const r = B - window.nc_pageLoad * 1e3, o = Date.now() - (r + window.nc_lastLogin * 1e3);
  return window.backendAllowsPasswordConfirmation && o > 30 * 60 * 1e3;
}, z = () => {
  if (!!document.getElementById(m))
    return Promise.reject(new Error(l("Password confirmation dialog already mounted")));
  if (!R())
    return Promise.resolve();
  const o = document.createElement("div");
  o.setAttribute("id", m);
  const e = document.querySelectorAll(".".concat($));
  !!e.length ? e[e.length - 1].prepend(o) : document.body.prepend(o);
  const a = w.extend(A), d = new a().$mount(o);
  return new Promise((c, f) => {
    d.$on("confirmed", () => {
      d.$destroy(), c();
    }), d.$on("close", () => {
      d.$destroy(), f(new Error("Dialog closed"));
    });
  });
};
export {
  z as confirmPassword,
  R as isPasswordConfirmationRequired
};
